;##################################################################
;
;   TesbWan for TI-86 (Bonus handling)
;
;   Programmed by Patrick Davidson (pad@calc.org)
;        
;   This program is in the public domain.  There is no warranty.
;
;   This file was last updated August 21, 2002.
;
;##################################################################

deploy_bonus:
        ld      hl,bonus_type
        ld      a,(hl)
        or      a
        ret     nz

        ld      a,(game_timer)
        rra
        rra
        rra
        and     3
        inc     a
        ld      (bonus_type),a
        call    get_block_coords
        ld      (bonus_y),de
        ret

handle_bonus:
        ld      a,(bonus_type)                  ; check if bonus exists
        dec     a
        ret     m
        add     a,a                             ; display bonus
        ld      hl,image_list   
        call    ADD_HL_A
        call    _ldHLind
        ld      de,(bonus_y)
        call    drw_spr

        ld      a,(game_timer)
        rra
        jr      c,bonus_move_done

        ld      hl,bonus_y                      ; move bonus down
        inc     (hl)
        ld      a,64                            ; check if off-screen
        cp      (hl)
        jr      z,kill_bonus
bonus_move_done:

        ld      a,(bonus_y)                     ; check if in bottom
        cp      57
        ret     c

        ld      a,(bonus_x)                    ; check if overlaps paddle
        ld      hl,paddle_x
        sub     (hl)
        add     a,7
        ret     m

        ld      b,23
        ld      hl,long_paddle
        bit     0,(hl)
        jr      z,bonus_short
        ld      b,31
bonus_short:

        cp      b
        ret     nc

        ld      a,(bonus_type)
        dec     a
        add     a,a
        ld      (smc_which_bonus+1),a
        call    smc_which_bonus

kill_bonus:
        xor     a
        ld      (bonus_type),a
        ret

;############## Bonus collection

smc_which_bonus:
        jr      smc_which_bonus
        jr      bonus1
        jr      bonus2
        jr      bonus3

bonus4: ld      a,(lives+1)
        cp      $86
        ret     z
        ccf
        inc     a
        daa
        ld      (lives+1),a
        ld      (lives_changed),a
        call    show_lives
        ret

bonus3: ld      hl,ball_speed
        ld      a,3
        cp      (hl)
        jr      z,no_slower
        dec     (hl)
no_slower:
        ld      hl,0
        ld      (game_timer),hl
        ret

bonus2: ld      hl,score+1
        ld      de,plus30+1
        jp      ADD_BCD

plus30: .db     $00,$30

bonus1: ld      a,1
        ld      (long_paddle),a
        ld      a,(paddle_x)
        add     a,23
        rra
        rra
        rra
        and     $1F
        ld      hl,working_map+(MAP_WIDTH*10)
        call    ADD_HL_A
        ld      a,(hl)
        or      a
        ret     z
        ld      a,(paddle_x)
        sub     8
        ld      (paddle_x),a
        ret

;############## Bonus images

image_list:
        .dw     img_expand
        .dw     img_points
        .dw     img_slow
        .dw     img_life

img_expand:
        .db     5
        .db     %00100100
        .db     %01100110
        .db     %11111111
        .db     %01100110
        .db     %00100100
        .db     %00100100
        .db     %01100110
        .db     %11111111
        .db     %01100110
        .db     %00100100

img_points:
        .db     5
        .db     %11100010
        .db     %00010101
        .db     %11100101
        .db     %00010101
        .db     %11100010
        .db     %11100010
        .db     %00010101
        .db     %11100101
        .db     %00010101
        .db     %11100010

img_slow:
        .db     5
        .db     %00000000
        .db     %01100000
        .db     %10010000
        .db     %10010000
        .db     %01100101
        .db     %00000000
        .db     %01100000
        .db     %11110000
        .db     %11110000
        .db     %01100101

img_life:
        .db     5
        .db     %00000000
        .db     %01111110
        .db     %10000001
        .db     %10000001
        .db     %01111110
        .db     %00000000
        .db     %01111110
        .db     %11111111
        .db     %11111111
        .db     %01111110

