;##################################################################
;
;   TesbWan for TI-86 (Paddle movement)
;
;   Programmed by Patrick Davidson (pad@calc.org)
;        
;   This program is in the public domain.  There is no warranty.
;
;   This file was last updated August 21, 2002.
;
;##################################################################

;############## Handle paddle movement

handle_paddle:
        ld      a,(getkeylastdata)
        bit     1,a
        call    z,go_left
        ld      a,(getkeylastdata)
        bit     2,a
        call    z,go_right

        ld      a,(paddle_x)
        ld      d,a
        ld      e,60
        ld      hl,paddle_image_left
        call    drw_spr

        ld      a,(paddle_x)
        add     a,8
        ld      d,a
        ld      e,60
        ld      a,(long_paddle)
        or      a
        jr      nz,show_long_paddle
        ld      hl,paddle_image_right
        jp      drw_spr

show_long_paddle:
        ld      hl,paddle_image_middle
        call    drw_spr
        ld      a,(paddle_x)
        add     a,16
        ld      d,a
        ld      e,60
        ld      hl,paddle_image_right
        jp      drw_spr

go_left:
        call    go_left_2
go_left_2:
        ld      a,(paddle_x)
        or      a
        ret     z

        dec     a
        rra
        rra
        rra
        and     31
        ld      hl,working_map+(MAP_WIDTH*10)
        call    ADD_HL_A
        ld      a,(hl)
        or      a
        ret     nz

        ld      hl,paddle_x
        dec     (hl)
        ld      a,(hl)
        ld      hl,screen_x
        sub     (hl)
        cp      32
        ret     nc
        jp      scroll_from_left

go_right:
        call    go_right_2
go_right_2:
        ld      a,(paddle_x)
        cp      (MAP_WIDTH-2)*8
        ret     z

        rra
        rra
        rra
        and     31
        ld      hl,long_paddle
        add     a,(hl)
        ld      hl,working_map+2+(MAP_WIDTH*10)
        call    ADD_HL_A
        ld      a,(hl)
        or      a
        ret     nz

        ld      hl,paddle_x
        inc     (hl)
        ld      a,(hl)
        ld      hl,screen_x
        sub     (hl)
        ld      hl,long_paddle
        bit     0,(hl)
        jr      z,no_long_right
        add     a,8
no_long_right:
        cp      64
        ret     c
        jp      scroll_from_right

paddle_image_left:
        .db     4
        .db     %01111111
        .db     %10000000
        .db     %10000000
        .db     %01111111
        .db     %01111111
        .db     %11111111
        .db     %11111111
        .db     %01111111
paddle_image_right:
        .db     4
        .db     %11111110
        .db     %00000001
        .db     %00000001
        .db     %11111110
        .db     %11111110
        .db     %11111111
        .db     %11111111
        .db     %11111110
paddle_image_middle:
        .db     4
        .db     %11111111
        .db     %00000000
        .db     %00000000
        .db     %11111111
        .db     %11111111
        .db     %11111111
        .db     %11111111
        .db     %11111111
